# NB  This won't work with openmpi for want of MPI_THREAD_MULTIPLE.

Name:		libmdhim
Version:	0.73
Release:	2%{?dist}
Summary:	Multi-Dimensional Hashing Indexing Middleware

Group:		System Environment/Libraries
# fixme: need licence
License:	unspecified
URL:		https://github.com/mdhim/mdhim-tng
Source0:	mdhim-tng-0.73.tar.gz
Patch1:		mdhim-shared.patch
Patch2:		mdhim-leveldb.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:	leveldb-devel mysql-devel mvapich2-devel mysql-connector-odbc
BuildRequires:	uthash-devel texlive-latex
Requires:	mvapich2

%description
MDHIM is a parallel key/value store framework written in MPI.
Unlike other big data solutions, MDHIM has been designed for an
HPC environment and to take advantage of high speed networks.


%package	devel
Summary:	Development files for %{name}
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	uthash-devel leveldb-devel

%description	devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%setup -q -n mdhim-tng-%version
%patch1 -p1 -b .shared
%patch2 -p1 -b .leveldb
rm -r src/uthash		# unbundled
# fixme: unbundle Mlog?  Not clear if it's a coherent library,
# and can't find the original

%build
%_mvapich2_load
make CC=mpicc CFLAGS="-fPIC $CFLAGS -pthread -DLEVELDB_SUPPORT" CINC="-IMlog" LEVEL_DB_ROOT=%_libdir %{?_smp_mflags}
pushd docs/latex
make
popd
%_mvapich2_unload


%install
rm -rf $RPM_BUILD_ROOT
%_mvapich2_load
mkdir -p $RPM_BUILD_ROOT$MPI_LIB $RPM_BUILD_ROOT$MPI_INCLUDE/mdhim/Mlog
install src/libmdhim.* $RPM_BUILD_ROOT$MPI_LIB
ln -s libmdhim.so $RPM_BUILD_ROOT$MPI_LIB
install src/Mlog/mlog.h src/Mlog/mlogfacs.h $RPM_BUILD_ROOT$MPI_INCLUDE/mdhim/Mlog
install src/{mdhim,data_store,range_server,messages,partitioner,mdhim_options}.h $RPM_BUILD_ROOT$MPI_INCLUDE/mdhim
%_mvapich2_unload

%clean
rm -rf $RPM_BUILD_ROOT


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%files
%defattr(-,root,root,-)
%doc README.md
%{_libdir}/mvapich2/lib/*.so.*

%files devel
%defattr(-,root,root,-)
%doc README.md docs/html docs/latex/*.pdf
%{_includedir}/mvapich2-%_arch/*
%{_libdir}/mvapich2/lib/*.so
%{_libdir}/mvapich2/lib/*.a


%changelog
* Tue Oct 21 2014 Dave Love <d.love@liverpool.ac.uk> - 0.73-2
- Install in the mvapich trees
- Link against leveldb
- Require uthash-devel, leveldb-devel for devel package

* Wed Jun  4 2014 Dave Love <d.love@liverpool.ac.uk> - 0.73-1
- Initial packaging
